import es, usermsg, time, cfglib

dm = es.import_addon('dm')
delay = dm.delay


class Settings(object):
    config = cfglib.AddonCFG(dm.addondir + '/dm/addons/respawntypes/wave/settings.cfg')
    _respawntime   = config.cvar('dm_wave_respawntime', 10.0, 'Respawn interval [Time after death/time between waves]'), float
    
    config.execute()
    
    def __init__(self):
        self.config.write()
        
    def __getattr__(self, name):
        if hasattr(Settings, name):
            return super(Settings, self).__getattribute__(name)
           
        elif hasattr(Settings, '_'+name):
            val, func = super(Settings, self).__getattribute__('_'+name)
            return func(val)
           
        raise AttributeError, 'No such attribute "%s"'%name
        
settings = Settings()


class Wave:
    def __inti__(self):
        self.nextspawn = False
    def end(self):
        delay.cancel('dm_wave')
        delay.cancel('dm_wave_hud')
        self.nextspawn = False
        
    def go(self):
        for userid in es.getUseridList():
            if not dm.isAlive(userid):
                dm.respawn(userid)
        
        d = settings.respawntime
        delay.delayed(d, 'dm_wave', self.go)
        self.nextspawn = time.time() + d
        
        self.hudloop()
        
    def hudloop(self):
        
        text = 'You will respawn in %s seconds'%int(self.nextspawn-time.time())
        usermsg.hudhint('#dead', text)
        delay.delayed(1, 'dm_wave_hud', self.hudloop)
        
respawn_wave = Wave()

def load():
    round_start(None)
    
def unload():
    respawn_wave.end()

def round_start(ev):
    delay.delayed(settings.respawntime, 'dm_wave', respawn_wave.go)
    
def round_end(ev):
    respawn_wave.end()